--- Makefile.orig	2008-02-14 06:39:18.000000000 -0600
+++ Makefile	2009-02-14 16:48:03.000000000 -0600
@@ -35,9 +35,9 @@
       decompress.o \
       bzlib.o
 
-all: libbz2.a bzip2 bzip2recover test
+all: libbz2.a libbz2.dylib bzip2 bzip2recover test
 
-bzip2: libbz2.a bzip2.o
+bzip2: libbz2.a libbz2.dylib bzip2.o
 	$(CC) $(CFLAGS) $(LDFLAGS) -o bzip2 bzip2.o -L. -lbz2
 
 bzip2recover: bzip2recover.o
@@ -52,15 +52,23 @@
 		$(RANLIB) libbz2.a ; \
 	fi
 
+libbz2.dylib: $(OBJS)
+	rm -f libbz2.dylib
+	$(CC) -dynamiclib $(OBJS) -o libbz2.__MacPorts_Version__.dylib \
+		-install_name $(PREFIX)/lib/libbz2.__MacPorts_Compatibility_Version__.dylib \
+		-compatibility_version __MacPorts_Compatibility_Version__ -current_version __MacPorts_Version__
+	ln -s libbz2.__MacPorts_Version__.dylib libbz2.__MacPorts_Compatibility_Version__.dylib
+	ln -s libbz2.__MacPorts_Version__.dylib libbz2.dylib
+
 check: test
 test: bzip2
 	@cat words1
-	./bzip2 -1  < sample1.ref > sample1.rb2
-	./bzip2 -2  < sample2.ref > sample2.rb2
-	./bzip2 -3  < sample3.ref > sample3.rb2
-	./bzip2 -d  < sample1.bz2 > sample1.tst
-	./bzip2 -d  < sample2.bz2 > sample2.tst
-	./bzip2 -ds < sample3.bz2 > sample3.tst
+	DYLD_LIBRARY_PATH=. ./bzip2 -1  < sample1.ref > sample1.rb2
+	DYLD_LIBRARY_PATH=. ./bzip2 -2  < sample2.ref > sample2.rb2
+	DYLD_LIBRARY_PATH=. ./bzip2 -3  < sample3.ref > sample3.rb2
+	DYLD_LIBRARY_PATH=. ./bzip2 -d  < sample1.bz2 > sample1.tst
+	DYLD_LIBRARY_PATH=. ./bzip2 -d  < sample2.bz2 > sample2.tst
+	DYLD_LIBRARY_PATH=. ./bzip2 -ds < sample3.bz2 > sample3.tst
 	cmp sample1.bz2 sample1.rb2 
 	cmp sample2.bz2 sample2.rb2
 	cmp sample3.bz2 sample3.rb2
@@ -89,6 +98,7 @@
 	chmod a+r $(PREFIX)/include/bzlib.h
 	cp -f libbz2.a $(PREFIX)/lib
 	chmod a+r $(PREFIX)/lib/libbz2.a
+	cp -f libbz2.__MacPorts_Version__.dylib $(PREFIX)/lib
 	cp -f bzgrep $(PREFIX)/bin/bzgrep
 	ln -s -f bzgrep $(PREFIX)/bin/bzegrep
 	ln -s -f bzgrep $(PREFIX)/bin/bzfgrep
@@ -109,7 +123,7 @@
 	ln -s -f bzdiff.1 $(PREFIX)/share/man/man1/bzcmp.1
 
 clean: 
-	rm -f *.o libbz2.a bzip2 bzip2recover \
+	rm -f *.o libbz2.a libbz2.*.dylib bzip2 bzip2recover \
 	sample1.rb2 sample2.rb2 sample3.rb2 \
 	sample1.tst sample2.tst sample3.tst
 
